var pocet_chyb = [0,0,0,0];
var opraveno = [0,0,0,0];
var zaznam_prohazeno = [0,[0,0,0,0],0];
var presunu = 0;

class tabulka{
    constructor(rodic,priklad){
        this.rodic = rodic; 
        this.obt = priklad;
        this.drag = "drag_"+priklad;
        this.drop = "drop_"+priklad;
        this.tabulka = document.createElement('table');
        this.zahlavi = ["Kostky","Mince","Hodiny","Karty","Digitálky","Lego"];   
        this.prefix = "image/";
        this.telo = [[1,"kostka"],[2,"mince"],[3,"hodiny"],[4,"karta"],[5,"digi"],[6,"lego"]];
        this.txt_kde = ["promíchaly některé obrázky v řádku","zamíchaly některé obrázky ve více řádcích", "pomíchaly některé údaje ve sloupci","zamíchala některá data"];
        this.ks = 1;
        this.pocet_chyb = 0;
    }
    
    print_txt(){
        let zadani = "Určitě už víš, co jsou tabulky, pojď si je se mnou procvičit. V tabulce se nám <strong>"+this.txt_kde[this.obt-1]+"</strong>. Pojďme je tedy doplnit na správná místa!";
        let tpl_p = document.getElementById("zadani_"+this.obt);
        tpl_p.innerHTML = zadani;
    }    
    show_tab(){
        let rodic = document.getElementById(this.rodic);
        this.tabulka.classList.add("cap3","kontrolujeme")
        let radek, bunka, hlava, x, y, obsah;               
        radek = this.tabulka.insertRow(-1);                  
        for(y=0;y<=6;y++){                                   //hlavicka
            hlava = document.createElement('th');
            obsah = document.createTextNode(y);
            if(y!=0)    
                hlava.appendChild(obsah);
            radek.appendChild(hlava);
        }                                                                 
        for(x = 0; x < 6; x++){                               //telo   
            radek = this.tabulka.insertRow(-1);
            for(y=0;y<=6;y++){
                bunka = radek.insertCell(-1);
                if(y==0)
                    obsah = document.createTextNode(this.zahlavi[x]);
                else{
                    obsah = document.createElement("img");
                    obsah.src = this.prefix+""+this.telo[x][1]+""+y+".png";
                    obsah.alt="obr";   
                    if(this.obt == 4){
                        bunka.dataset['id'] = "obr_"+this.ks;
                        obsah.dataset['id'] = "obr_"+this.ks;
                        obsah.id = "obr_"+this.ks;
                        this.ks++;  
                    }                                       
                }     
                bunka.appendChild(obsah);
            }
        }          
        rodic.appendChild(this.tabulka);
    }
    //prida tabulku s pocitani
    addCounter(){
        let rodic = document.getElementById(this.rodic);
        let radek, bunka, bunkaH;
        let table = document.createElement('table');
        table.classList.add("cap3");
        radek = table.insertRow();
        bunkaH = document.createElement('td');
        bunka = document.createElement('td');
        if (this.obt == 3){
            bunkaH.innerHTML = "Počet přesunů:";
            bunka.innerHTML = "0";
            bunka.setAttribute("id","zaznamPresuny");
        }     
        else{
            bunkaH.innerHTML = "Počet obrázků na špatném místě:";
            bunka.innerHTML = pocet_chyb[3];
            bunka.setAttribute("id", "zaznamChyb");
        }
        radek.appendChild(bunkaH);
        radek.appendChild(bunka);        
        rodic.appendChild(table);
    }
    
    /*prohazeni prvku v poli */
    prohazej(){
      let tmp_pole = [];
      for(let i = 0; i<this.telo.length;i++)
        tmp_pole[i] = this.telo[i];
      let tmp_int, tmp_tmp;
      for(let i = 0; i< this.telo.length;i++){
        tmp_int = random_int(0,this.telo.length-1);
        tmp_tmp = tmp_pole[i];
        
        tmp_pole[i] = tmp_pole[tmp_int];
        tmp_pole[tmp_int] = tmp_tmp;
      } 
      return tmp_pole;
    }
    
    prohazej_radek(){
      let rand_int = random_int(1,6);
      let rand_radek = this.prohazej(this.telo);
      zaznam_prohazeno[0] = rand_int;
      for(let i = 1; i<=6;i++){
        if(i != rand_radek[i-1][0]){
          this.tabulka.childNodes[0].children[rand_int].cells[i].innerHTML = '<img src="'+this.prefix+""+this.telo[rand_int-1][1]+''+rand_radek[i-1][0]+'.png" alt="obr" class="'+this.drag+' ui-draggable ui-draggable-handle" data-pr="0" data-id="'+rand_radek[i-1][0]+'" />';
          this.tabulka.childNodes[0].children[rand_int].cells[i].classList.add(this.drop, "ui-droppable");
          this.tabulka.childNodes[0].children[rand_int].cells[i].dataset['id'] = i;
          this.pocet_chyb++;
        }        
      }       
    }
    
    prohazej_vice_radku(){ 
      let rand_radek;
      let rand_int;
      for(let x = 0; x<=3;x++){
        rand_radek = this.prohazej(this.telo);
        rand_int = random_int(1,6);  
        if (zaznam_prohazeno[1].includes(rand_int) == false){
            zaznam_prohazeno[1][x] = rand_int;       
            for(let i = 1; i<=6;i++){
                if(i != rand_radek[i-1][0]){
                    this.tabulka.childNodes[0].children[rand_int].cells[i].innerHTML = '<img src="'+this.prefix+''+this.telo[rand_int-1][1]+''+rand_radek[i-1][0]+'.png" alt="obr" class="'+this.drag+' ui-draggable ui-draggable-handle" data-pr="1" data-id="'+x+''+rand_radek[i-1][0]+'" />';
                    this.tabulka.childNodes[0].children[rand_int].cells[i].classList.add(this.drop, "ui-droppable");
                    this.tabulka.childNodes[0].children[rand_int].cells[i].dataset['id'] = x+""+i;
                    this.tabulka.childNodes[0].children[rand_int].cells[i].dataset['pr'] = this.obt;
                    this.pocet_chyb++;
                }        
            }
        }else   x--;
      }          
    }
    
    prohazej_sloupce(){
        let rand_sloupec = this.prohazej(this.telo);
        let rand_int = random_int(1,6);
        zaznam_prohazeno[2] = rand_int;
        for(let i = 1; i<=6;i++){ 
            if(i != rand_sloupec[i-1][0]){                      
              this.tabulka.childNodes[0].children[i].cells[rand_int].innerHTML = '<img src="'+this.prefix+''+rand_sloupec[i-1][1]+''+rand_int+'.png" alt="obr" class="'+this.drag+' ui-draggable ui-draggable-handle" data-pr="2" data-id="'+rand_sloupec[i-1][1]+'" />';
              this.tabulka.childNodes[0].children[i].cells[rand_int].classList.add(this.drop, "ui-droppable");
              this.tabulka.childNodes[0].children[i].cells[rand_int].dataset['id'] = this.telo[i-1][1];  
              this.tabulka.childNodes[0].children[i].cells[rand_int].dataset['pr'] = this.obt;
              this.pocet_chyb++;
            }
        }  
    }
    
    prohazej_vse(){
        for(let x = 0; x <15; x++){ 
          let rand_1 = random_int(1,35);              
          let rand_2 = random_int(1,35);
          
          let tmp_item_1 = document.getElementById("obr_"+rand_1);
          let tmp_item_2 = document.getElementById("obr_"+rand_2);
          
          let tmp_storage = tmp_item_1.src;                            
          tmp_item_1.src = tmp_item_2.src;
          tmp_item_2.src = tmp_storage;
          
          tmp_storage = tmp_item_1.dataset['id'];
          tmp_item_1.dataset['id'] = tmp_item_2.dataset['id'];
          tmp_item_2.dataset['id'] = tmp_storage;
          
          tmp_item_1.dataset['pr'] =  tmp_item_2.dataset['pr'] = 3;
          
          tmp_item_1.classList.add(this.drag, "ui-draggable", "ui-draggable-handle");
          tmp_item_2.classList.add(this.drag, "ui-draggable", "ui-draggable-handle");
          
          tmp_item_1.parentNode.classList.add(this.drop, "ui-droppable");
          tmp_item_2.parentNode.classList.add(this.drop, "ui-droppable"); 
        }
        
        //odstranim si IDcka
         for(let x = 1; x < 36; x++){
            let tpl = document.getElementById("obr_"+x);
            tpl.removeAttribute("id");
            if(tpl.dataset['id'] == tpl.parentNode.dataset['id']){
                tpl.removeAttribute("data-id");
                tpl.removeAttribute("data-pr");
                tpl.parentNode.removeAttribute("data-id");
            }else
                this.pocet_chyb++;              
         }              
    }
    
    setDrag(){
        pocet_chyb[this.obt-1] = this.pocet_chyb;
        jQuery("."+this.drag).draggable({ revert: "invalid" });  
        jQuery("."+this.drop).droppable({                                  //anonymni funkce
            drop: function( event, ui ) {
            event.preventDefault();                                        //priprava dat
            let presouvane = ui.draggable[0];                              //presouvany
            let kam = event.target                                         //budouci rodic
            let tpl_druhy = kam.children[0];                               //druhy preesouvny
            let pres_rodic = presouvane.parentElement;                     //puvodni rodic
            kam.children[0].remove();                                      //smazu presouvaneho
            if (parseInt(presouvane.dataset['pr']) == 2){
                presunu++; 
                updateCounter(2)
            }  
            if(presouvane.dataset['id'] == kam.dataset['id']){             //prvni presun - ok
                if (parseInt(presouvane.dataset['pr']) != 3)               //v poslednim priklade to neobarvuji vubec
                    kam.style.backgroundColor = "rgba(0,255,0,0.25)";
                jQuery(kam).droppable("destroy");                          //zbavim se funkce
                jQuery(presouvane).draggable("destroy");
                kam.appendChild(presouvane);      
                presouvane.removeAttribute("style");  
                opraveno[parseInt(presouvane.dataset['pr'])]++;
                if(opraveno[parseInt(presouvane.dataset['pr'])] == pocet_chyb[parseInt(presouvane.dataset['pr'])]){
                    print_modal("modal","ok");
                    switch(parseInt(presouvane.dataset['pr'])){
                        case 0: obarvi_radek(kam.parentElement); break;
                        case 2: obarvi_sloupec(kam.parentElement.parentElement, zaznam_prohazeno[2]); break;
                    }
                }
            }else{                                                         //prvni presun - nok
                if (parseInt(presouvane.dataset['pr']) != 3)
                    kam.style.backgroundColor = "rgba(255,0,0,0.25)";
                kam.appendChild(presouvane);
                jQuery(presouvane).draggable();
                presouvane.style.left = "0px";
                presouvane.style.top = "0px";
            }              
            
            if(pres_rodic.dataset['id'] == tpl_druhy.dataset['id']){       //druhy presun - ok
                if (parseInt(presouvane.dataset['pr']) != 3)               //v poslednim priklade to neobarvuji vubec
                    pres_rodic.style.backgroundColor = "rgba(0,255,0,0.25)";
                jQuery(pres_rodic).droppable("destroy");                   //zbavim se funkce 
                jQuery(tpl_druhy).draggable("destroy");
                pres_rodic.appendChild(tpl_druhy);  
                tpl_druhy.removeAttribute("style");
                opraveno[parseInt(tpl_druhy.dataset['pr'])]++;
                if(opraveno[parseInt(presouvane.dataset['pr'])] == pocet_chyb[parseInt(presouvane.dataset['pr'])]){
                    print_modal("modal","ok");
                    switch(parseInt(presouvane.dataset['pr'])){
                        case 0: obarvi_radek(kam.parentElement); break;
                        case 2: obarvi_sloupec(kam.parentElement.parentElement, zaznam_prohazeno[2]); break;
                    }
                }                    
            } else {  //druhy presun - nok
                if (parseInt(presouvane.dataset['pr']) == 1)      //dvojite obarvovani je pouze u př 2 (1 kvuli indexovani)                                                 
                    pres_rodic.style.backgroundColor = "rgba(255,0,0,0.25)";
                pres_rodic.appendChild(tpl_druhy);
                jQuery(tpl_druhy).draggable();
                tpl_druhy.style.left = "0px";
                tpl_druhy.style.top = "0px";        
            } 
            
                if (parseInt(presouvane.dataset['pr']) == 3) {  //snizovani zaznmu chyb
                    updateCounter(3);
                }
            
            }
        });       
    }          
}

function updateCounter(obt) {
    if(obt == 2)
        document.getElementById("zaznamPresuny").innerHTML = presunu;
    else
        document.getElementById("zaznamChyb").innerHTML = pocet_chyb[3] - opraveno[3];   
}

function obarvi_radek(radek){
    for(let i = 1; i < radek.children.length; i++)
        radek.children[i].style.backgroundColor = "rgba(0,255,0,0.25)";
}

function obarvi_sloupec(tabulka, index){
    for(let i = 1; i < tabulka.children.length; i++)
       tabulka.children[i].children[index].style.backgroundColor = "rgba(0,255,0,0.25)";
}

var tabulka_1 = new tabulka('tab_kon_1',1);
tabulka_1.print_txt();
tabulka_1.show_tab();
tabulka_1.prohazej_radek();  
tabulka_1.setDrag();

var tabulka_2 = new tabulka('tab_kon_2',2);
tabulka_2.print_txt();
tabulka_2.show_tab();
tabulka_2.prohazej_vice_radku();
tabulka_2.setDrag();

var tabulka_3 = new tabulka('tab_kon_3',3);
tabulka_3.print_txt();
tabulka_3.show_tab();
tabulka_3.prohazej_sloupce();
tabulka_3.addCounter();
tabulka_3.setDrag();

var tabulka_4 = new tabulka('tab_kon_4',4);
tabulka_4.print_txt();
tabulka_4.show_tab();
tabulka_4.prohazej_vse();
tabulka_4.setDrag(); 
tabulka_4.addCounter();



